<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Scene.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_scene_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Scene.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_scene_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Scene_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Scene_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_surface_8hpp.html">Surface.hpp</a>&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_triangle_8hpp.html">Triangle.hpp</a>&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_sphere_8hpp.html">Sphere.hpp</a>&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_mesh_8hpp.html">Mesh.hpp</a>&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_light_8hpp.html">Light.hpp</a>&quot;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_b_v_h_8h.html">BVH.h</a>&quot;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_scene.html">   23</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_scene.html">Scene</a> {</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keywordtype">double</span> tmp;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;   </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    </div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_scene.html#a0196c28bebf7f0cd29345066887ac4f1">   31</a></span>&#160;    std::vector&lt;Surface*&gt; <a class="code" href="class_scene.html#a0196c28bebf7f0cd29345066887ac4f1">surfaces</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="class_scene.html#a6fc93379440340cecd060235a1b9f69a">   34</a></span>&#160;    std::vector&lt;Surface*&gt; <a class="code" href="class_scene.html#a6fc93379440340cecd060235a1b9f69a">objects</a>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_scene.html#a979988030703212b02a2ce950b5ed0a6">   38</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a> <a class="code" href="class_scene.html#a979988030703212b02a2ce950b5ed0a6">root_tf</a>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_scene.html#a45b8655cf456ce0383290db41f2b7c0b">   41</a></span>&#160;    <a class="code" href="class_b_v_h.html">BVH</a> <a class="code" href="class_scene.html#a45b8655cf456ce0383290db41f2b7c0b">bvh</a>;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="class_scene.html#a4ecc3182a80435e1c4dfbe1b20e559bd">   44</a></span>&#160;    std::vector&lt;Light*&gt; <a class="code" href="class_scene.html#a4ecc3182a80435e1c4dfbe1b20e559bd">lights</a>;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <a class="code" href="class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene</a>();</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_scene.html#af9c3da4fc4d5a31613601a23543abb92">   53</a></span>&#160;    std::vector&lt;Surface*&gt;* <a class="code" href="class_scene.html#af9c3da4fc4d5a31613601a23543abb92">getSurfacesVector</a>(){<span class="keywordflow">return</span> &amp;<a class="code" href="class_scene.html#a0196c28bebf7f0cd29345066887ac4f1">surfaces</a>;}</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="class_scene.html#acaf6d293b31f7ebcf20f1c9195ac4473">   59</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a>* <a class="code" href="class_scene.html#acaf6d293b31f7ebcf20f1c9195ac4473">getRootTransform</a>(){<span class="keywordflow">return</span> &amp;<a class="code" href="class_scene.html#a979988030703212b02a2ce950b5ed0a6">root_tf</a>;}</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="class_scene.html#a2510b15715c974c567cffef03f1afa1f">   65</a></span>&#160;    std::vector&lt;Light*&gt;* <a class="code" href="class_scene.html#a2510b15715c974c567cffef03f1afa1f">getLightsVector</a>(){<span class="keywordflow">return</span> &amp;<a class="code" href="class_scene.html#a4ecc3182a80435e1c4dfbe1b20e559bd">lights</a>;}</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <a class="code" href="class_surface.html">Surface</a>* <a class="code" href="class_scene.html#a6e766a2cb866e58fb4e2d529b5937890">surfaceFromID</a>(std::string _id);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <a class="code" href="class_triangle.html">Triangle</a>* <a class="code" href="class_scene.html#adf0478423fdf556ddb7759ad358e1597">triangleFromID</a>(std::string _id);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="class_sphere.html">Sphere</a>* <a class="code" href="class_scene.html#a0747eea84e4436d8f9a80e47ee1cfc66">sphereFromID</a>(std::string _id);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <a class="code" href="class_mesh.html">Mesh</a>* <a class="code" href="class_scene.html#ad7dfd803c8a3e7c5379ec9866206b4f3">meshFromID</a>(std::string _id);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="class_scene.html#add3094f0f28ce5af3ceba0c73332cff9">  100</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_scene.html#add3094f0f28ce5af3ceba0c73332cff9">addSurface</a>(<a class="code" href="class_surface.html">Surface</a>* _surface, std::string _id) {surfaces.push_back(_surface);_surface-&gt;<a class="code" href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">setID</a>(_id);};</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="class_scene.html#a9ecf32c817a0b506a7bec7d0cca62993">  106</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_scene.html#a9ecf32c817a0b506a7bec7d0cca62993">addSurface</a>(<a class="code" href="class_surface.html">Surface</a>* _surface) {surfaces.push_back(_surface);};</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="class_scene.html#a60b89dee490379b29841bb89bdc2de4f">  112</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_scene.html#a60b89dee490379b29841bb89bdc2de4f">removeSurface</a>(<span class="keywordtype">int</span> _index) {surfaces.erase(surfaces.begin()+_index);};</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="class_scene.html#a5715863fe55bc46732c50ffc496e0f33">  118</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_scene.html#a5715863fe55bc46732c50ffc496e0f33">addLight</a>(<a class="code" href="class_light.html">Light</a>* _light) {lights.push_back(_light);};</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_scene.html#a58a0cf5a161223752ab530141dd67df7">hit</a>(<span class="keyword">const</span> <a class="code" href="class_ray.html">Ray</a> &amp;r, <a class="code" href="structhit__rec.html">hit_rec</a> &amp;h_r, <span class="keywordtype">double</span> t_min, <span class="keywordtype">double</span> t_max, <a class="code" href="class_surface.html">Surface</a> *light_geode);</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    </div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <a class="code" href="class_ray.html">Ray</a> <a class="code" href="class_scene.html#a428607516caaa0d83047574c4e77ce70">reflection</a>(<a class="code" href="class_ray.html">Ray</a> &amp;ray, <a class="code" href="structhit__rec.html">hit_rec</a> h_r);</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    </div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <a class="code" href="class_ray.html">Ray</a> <a class="code" href="class_scene.html#a6849be73b0e7e50ec55d1e7a8d0c1ec4">refraction</a>(<a class="code" href="class_ray.html">Ray</a> &amp;ray, <a class="code" href="structhit__rec.html">hit_rec</a> h_r, <span class="keywordtype">double</span> &amp;R);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    </div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_scene.html#aa164a99f7b7b95f91ad96c065da409d5">transform</a>();</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_scene.html#a9d206b4dd94733867c8f07834319a2a1">setBVH</a>();</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;};</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_scene_html_aa164a99f7b7b95f91ad96c065da409d5"><div class="ttname"><a href="class_scene.html#aa164a99f7b7b95f91ad96c065da409d5">Scene::transform</a></div><div class="ttdeci">void transform()</div><div class="ttdoc">Triggers the application of all transforms defined for all Surface and Light objects with setTransfor...</div><div class="ttdef"><b>Definition:</b> Scene.cpp:116</div></div>
<div class="ttc" id="class_scene_html_acaf6d293b31f7ebcf20f1c9195ac4473"><div class="ttname"><a href="class_scene.html#acaf6d293b31f7ebcf20f1c9195ac4473">Scene::getRootTransform</a></div><div class="ttdeci">Transform * getRootTransform()</div><div class="ttdoc">Returns a pointer to Root transform associated to the Scene. All transforms need to under (directly o...</div><div class="ttdef"><b>Definition:</b> Scene.hpp:59</div></div>
<div class="ttc" id="class_scene_html_a0747eea84e4436d8f9a80e47ee1cfc66"><div class="ttname"><a href="class_scene.html#a0747eea84e4436d8f9a80e47ee1cfc66">Scene::sphereFromID</a></div><div class="ttdeci">Sphere * sphereFromID(std::string _id)</div><div class="ttdoc">Returns a pointer to the sphere with a given ID. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:29</div></div>
<div class="ttc" id="class_mesh_html"><div class="ttname"><a href="class_mesh.html">Mesh</a></div><div class="ttdoc">A class to create and manipulate triangular meshes. </div><div class="ttdef"><b>Definition:</b> Mesh.hpp:19</div></div>
<div class="ttc" id="_light_8hpp_html"><div class="ttname"><a href="_light_8hpp.html">Light.hpp</a></div></div>
<div class="ttc" id="class_surface_html_ab59cc271b2fe0db25867fc16664cc22f"><div class="ttname"><a href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">Surface::setID</a></div><div class="ttdeci">void setID(std::string _id)</div><div class="ttdoc">Sets a unique identifier for this Surface. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:85</div></div>
<div class="ttc" id="class_scene_html_a428607516caaa0d83047574c4e77ce70"><div class="ttname"><a href="class_scene.html#a428607516caaa0d83047574c4e77ce70">Scene::reflection</a></div><div class="ttdeci">Ray reflection(Ray &amp;ray, hit_rec h_r)</div><div class="ttdoc">Returns a reflection Ray, given an incinding Ray and corresponding surface-hit record. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:60</div></div>
<div class="ttc" id="class_scene_html_adf0478423fdf556ddb7759ad358e1597"><div class="ttname"><a href="class_scene.html#adf0478423fdf556ddb7759ad358e1597">Scene::triangleFromID</a></div><div class="ttdeci">Triangle * triangleFromID(std::string _id)</div><div class="ttdoc">Returns a pointer to the triangle with a given ID. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:25</div></div>
<div class="ttc" id="class_surface_html"><div class="ttname"><a href="class_surface.html">Surface</a></div><div class="ttdoc">A base class for every geometry class (e.g., Sphere, Triangle, Mesh). </div><div class="ttdef"><b>Definition:</b> Surface.hpp:40</div></div>
<div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_scene_html_a2510b15715c974c567cffef03f1afa1f"><div class="ttname"><a href="class_scene.html#a2510b15715c974c567cffef03f1afa1f">Scene::getLightsVector</a></div><div class="ttdeci">std::vector&lt; Light * &gt; * getLightsVector()</div><div class="ttdoc">Returns a pointer to the vector of Lights belonging to the Scene. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:65</div></div>
<div class="ttc" id="class_light_html"><div class="ttname"><a href="class_light.html">Light</a></div><div class="ttdoc">A class to create and manipulate light sources. </div><div class="ttdef"><b>Definition:</b> Light.hpp:16</div></div>
<div class="ttc" id="class_triangle_html"><div class="ttname"><a href="class_triangle.html">Triangle</a></div><div class="ttdoc">A class to create and manipulate triangles. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:16</div></div>
<div class="ttc" id="class_scene_html_a9ecf32c817a0b506a7bec7d0cca62993"><div class="ttname"><a href="class_scene.html#a9ecf32c817a0b506a7bec7d0cca62993">Scene::addSurface</a></div><div class="ttdeci">void addSurface(Surface *_surface)</div><div class="ttdoc">Adds a surface to the scene. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:106</div></div>
<div class="ttc" id="class_scene_html_af9c3da4fc4d5a31613601a23543abb92"><div class="ttname"><a href="class_scene.html#af9c3da4fc4d5a31613601a23543abb92">Scene::getSurfacesVector</a></div><div class="ttdeci">std::vector&lt; Surface * &gt; * getSurfacesVector()</div><div class="ttdoc">Returns a pointer to the vector of surfaces belonging to the Scene. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:53</div></div>
<div class="ttc" id="class_b_v_h_html"><div class="ttname"><a href="class_b_v_h.html">BVH</a></div><div class="ttdef"><b>Definition:</b> BVH.h:18</div></div>
<div class="ttc" id="class_scene_html_ad7dfd803c8a3e7c5379ec9866206b4f3"><div class="ttname"><a href="class_scene.html#ad7dfd803c8a3e7c5379ec9866206b4f3">Scene::meshFromID</a></div><div class="ttdeci">Mesh * meshFromID(std::string _id)</div><div class="ttdoc">Returns a pointer to the mesh with a given ID. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:33</div></div>
<div class="ttc" id="class_scene_html_a6e766a2cb866e58fb4e2d529b5937890"><div class="ttname"><a href="class_scene.html#a6e766a2cb866e58fb4e2d529b5937890">Scene::surfaceFromID</a></div><div class="ttdeci">Surface * surfaceFromID(std::string _id)</div><div class="ttdoc">Returns a pointer to the surface with a given ID. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:16</div></div>
<div class="ttc" id="class_scene_html_a4ecc3182a80435e1c4dfbe1b20e559bd"><div class="ttname"><a href="class_scene.html#a4ecc3182a80435e1c4dfbe1b20e559bd">Scene::lights</a></div><div class="ttdeci">std::vector&lt; Light * &gt; lights</div><div class="ttdoc">Vector containing pointers to all Light objects to be used while rendering. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:44</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_scene_html_a6fc93379440340cecd060235a1b9f69a"><div class="ttname"><a href="class_scene.html#a6fc93379440340cecd060235a1b9f69a">Scene::objects</a></div><div class="ttdeci">std::vector&lt; Surface * &gt; objects</div><div class="ttdoc">An internal structure (do not use it). </div><div class="ttdef"><b>Definition:</b> Scene.hpp:34</div></div>
<div class="ttc" id="class_scene_html_ad10176d75a9cc0da56626f682d083507"><div class="ttname"><a href="class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene::Scene</a></div><div class="ttdeci">Scene()</div><div class="ttdoc">A straighforward Scene constructor. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:8</div></div>
<div class="ttc" id="class_scene_html_a0196c28bebf7f0cd29345066887ac4f1"><div class="ttname"><a href="class_scene.html#a0196c28bebf7f0cd29345066887ac4f1">Scene::surfaces</a></div><div class="ttdeci">std::vector&lt; Surface * &gt; surfaces</div><div class="ttdoc">Vector containing pointers to all Surface objects that are to be rendered. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:31</div></div>
<div class="ttc" id="class_scene_html_a45b8655cf456ce0383290db41f2b7c0b"><div class="ttname"><a href="class_scene.html#a45b8655cf456ce0383290db41f2b7c0b">Scene::bvh</a></div><div class="ttdeci">BVH bvh</div><div class="ttdoc">The bounding volume hierarchy object. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:41</div></div>
<div class="ttc" id="class_scene_html"><div class="ttname"><a href="class_scene.html">Scene</a></div><div class="ttdoc">A class to create and control scenes from Surface and Light objects. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:23</div></div>
<div class="ttc" id="class_scene_html_add3094f0f28ce5af3ceba0c73332cff9"><div class="ttname"><a href="class_scene.html#add3094f0f28ce5af3ceba0c73332cff9">Scene::addSurface</a></div><div class="ttdeci">void addSurface(Surface *_surface, std::string _id)</div><div class="ttdoc">Adds a surface to the scene and associates to it an ID (unique identifier). </div><div class="ttdef"><b>Definition:</b> Scene.hpp:100</div></div>
<div class="ttc" id="_triangle_8hpp_html"><div class="ttname"><a href="_triangle_8hpp.html">Triangle.hpp</a></div></div>
<div class="ttc" id="class_scene_html_a5715863fe55bc46732c50ffc496e0f33"><div class="ttname"><a href="class_scene.html#a5715863fe55bc46732c50ffc496e0f33">Scene::addLight</a></div><div class="ttdeci">void addLight(Light *_light)</div><div class="ttdoc">Adds a light source to the scene. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:118</div></div>
<div class="ttc" id="class_sphere_html"><div class="ttname"><a href="class_sphere.html">Sphere</a></div><div class="ttdoc">A class to create and manipulate spheres. </div><div class="ttdef"><b>Definition:</b> Sphere.hpp:17</div></div>
<div class="ttc" id="_sphere_8hpp_html"><div class="ttname"><a href="_sphere_8hpp.html">Sphere.hpp</a></div></div>
<div class="ttc" id="class_scene_html_a58a0cf5a161223752ab530141dd67df7"><div class="ttname"><a href="class_scene.html#a58a0cf5a161223752ab530141dd67df7">Scene::hit</a></div><div class="ttdeci">bool hit(const Ray &amp;r, hit_rec &amp;h_r, double t_min, double t_max, Surface *light_geode)</div><div class="ttdef"><b>Definition:</b> Scene.cpp:47</div></div>
<div class="ttc" id="class_scene_html_a6849be73b0e7e50ec55d1e7a8d0c1ec4"><div class="ttname"><a href="class_scene.html#a6849be73b0e7e50ec55d1e7a8d0c1ec4">Scene::refraction</a></div><div class="ttdeci">Ray refraction(Ray &amp;ray, hit_rec h_r, double &amp;R)</div><div class="ttdoc">Returns a refraction Ray, given an incinding Ray and corresponding surface-hit record. </div><div class="ttdef"><b>Definition:</b> Scene.cpp:75</div></div>
<div class="ttc" id="_surface_8hpp_html"><div class="ttname"><a href="_surface_8hpp.html">Surface.hpp</a></div></div>
<div class="ttc" id="class_scene_html_a9d206b4dd94733867c8f07834319a2a1"><div class="ttname"><a href="class_scene.html#a9d206b4dd94733867c8f07834319a2a1">Scene::setBVH</a></div><div class="ttdeci">void setBVH()</div><div class="ttdef"><b>Definition:</b> Scene.cpp:38</div></div>
<div class="ttc" id="_mesh_8hpp_html"><div class="ttname"><a href="_mesh_8hpp.html">Mesh.hpp</a></div></div>
<div class="ttc" id="class_scene_html_a979988030703212b02a2ce950b5ed0a6"><div class="ttname"><a href="class_scene.html#a979988030703212b02a2ce950b5ed0a6">Scene::root_tf</a></div><div class="ttdeci">Transform root_tf</div><div class="ttdef"><b>Definition:</b> Scene.hpp:38</div></div>
<div class="ttc" id="_b_v_h_8h_html"><div class="ttname"><a href="_b_v_h_8h.html">BVH.h</a></div></div>
<div class="ttc" id="class_scene_html_a60b89dee490379b29841bb89bdc2de4f"><div class="ttname"><a href="class_scene.html#a60b89dee490379b29841bb89bdc2de4f">Scene::removeSurface</a></div><div class="ttdeci">void removeSurface(int _index)</div><div class="ttdoc">Removes a surface from the scene, given its position in the vector of surfaces. </div><div class="ttdef"><b>Definition:</b> Scene.hpp:112</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="structhit__rec_html"><div class="ttname"><a href="structhit__rec.html">hit_rec</a></div><div class="ttdoc">A structure used to hold information regarding ray-surface intersection events. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:20</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_scene_8hpp.html">Scene.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
